"use strict";
/*
Sequential Generator to return NZ-style registration plates
*/
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generatePlates = void 0;
function generatePlates(init) {
    var plate, letters, number, shouldIncrementLetters, newNumber, _a, char1, char2, char3;
    if (init === void 0) { init = 'AAA100'; }
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!init.match(/[A-Z]{3}[1-9][0-9]{2}/))
                    throw new Error('Incorrect registration plate format');
                plate = init;
                return [4 /*yield*/, plate]; // First one before loop
            case 1:
                _b.sent(); // First one before loop
                _b.label = 2;
            case 2:
                if (!(plate !== 'ZZZ999')) return [3 /*break*/, 4];
                letters = plate.slice(0, 3);
                number = Number(plate.slice(3, 6));
                shouldIncrementLetters = number === 999;
                newNumber = shouldIncrementLetters ? 100 : number + 1;
                _a = Array.from(letters).map(function (letter) { return letter.charCodeAt(0); }), char1 = _a[0], char2 = _a[1], char3 = _a[2];
                if (shouldIncrementLetters) {
                    if (char3 === 90) {
                        char3 = 65;
                        char2++;
                        if (char2 === 91) {
                            char2 = 65;
                            char1++;
                        }
                    }
                    else
                        char3++;
                }
                plate = [char1, char2, char3].map(function (code) { return String.fromCharCode(code); }).join('') + newNumber;
                return [4 /*yield*/, plate];
            case 3:
                _b.sent();
                return [3 /*break*/, 2];
            case 4: return [2 /*return*/];
        }
    });
}
exports.generatePlates = generatePlates;
