"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runDemo = void 0;
var patterns_1 = __importDefault(require("./patterns"));
var axios_1 = __importDefault(require("axios"));
var customCounters_1 = require("./customCounters");
var checkdigit = require('checkdigit');
// Basic pattern generator, using internal counters and no customReplacers
var basicPattern = new patterns_1.default(/[A-Za-z]{4,9}-<+ddd>/);
// Between 1 and 9 alphabet chars, followed by - and a number padded with leading 0s to 3 digits
var showBasicPattern = function () { return __awaiter(void 0, void 0, void 0, function () {
    var i, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                console.log('Basic pattern -- between 1-9 random alphabet chars, followed by an incrementing number padded with 0s, seperated by hyphen:');
                i = 1;
                _c.label = 1;
            case 1:
                if (!(i < 20)) return [3 /*break*/, 4];
                _b = (_a = console).log;
                return [4 /*yield*/, basicPattern.gen()];
            case 2:
                _b.apply(_a, [_c.sent()]);
                _c.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}); };
// Function to fetch an item from an online API
var getAlbumString = function (key) { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, axios_1.default.get('https://jsonplaceholder.typicode.com/albums')];
            case 1:
                response = _a.sent();
                return [2 /*return*/, response.data[key].title];
        }
    });
}); };
// More complex pattern with 2 custom replacers and a Intl formatted counter, and a non-standard incrementing function
var fancyPattern = new patterns_1.default(/Album name: <?album>, serial: [A-Z]{3}_<+d> \(<?upper>\)/, {
    counterInit: 5000,
    counterIncrement: function (prev) { return Number(prev) + 100; },
    customReplacers: {
        album: getAlbumString,
        upper: function (str) { return str.toUpperCase(); },
    },
    numberFormat: new Intl.NumberFormat('en-US'),
});
var showFancyPattern = function () { return __awaiter(void 0, void 0, void 0, function () {
    var i, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                console.log('\n\nA more complex pattern with 2 custom replacers and an Intl.NumberFormat formatted counter with a non-standard incrementing function');
                i = 1;
                _c.label = 1;
            case 1:
                if (!(i < 5)) return [3 /*break*/, 4];
                _b = (_a = console).log;
                return [4 /*yield*/, fancyPattern.gen({
                        customArgs: {
                            album: i,
                            upper: String.fromCharCode(i + 65),
                        },
                    })];
            case 2:
                _b.apply(_a, [_c.sent()]);
                _c.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}); };
// NZ Number plate generator:
var plates = customCounters_1.generatePlates();
var platePattern = new patterns_1.default('Sequential: <+>  Random: [A-Z]{3}[1-9][0-9]{2}', {
    getCounter: function () { return plates.next(); },
});
var showPlates = function () { return __awaiter(void 0, void 0, void 0, function () {
    var i, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                console.log('\n\nGenerate NZ-style car number plates in sequence');
                i = 1;
                _c.label = 1;
            case 1:
                if (!(i < 20)) return [3 /*break*/, 4];
                _b = (_a = console).log;
                return [4 /*yield*/, platePattern.gen()];
            case 2:
                _b.apply(_a, [_c.sent()]);
                _c.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}); };
// Generate credit card numbers with valid checksum
var generateChecksum = function (digits) {
    return checkdigit.mod10.create(digits.join('').replace(/\W/g, ''));
};
var cardTypeLookup = function (initDigits) {
    var startDigitReference = {
        4: 'Visa',
        5: 'Mastercard',
    };
    return startDigitReference[initDigits.slice(0, 1)];
};
var creditCardGenerator = new patterns_1.default(/(4[0-9]|51|52|53|54|55)([0-9]{2}) ([0-9]{4} [0-9]{4} [0-9]{3})<?checksum(1, 2, 3)> \(<?whichCard(1)>\)/, {
    customReplacers: {
        checksum: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return generateChecksum(args);
        },
        whichCard: cardTypeLookup,
    },
});
var generateCreditCardNums = function () { return __awaiter(void 0, void 0, void 0, function () {
    var i, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                console.log('\n\nRandom credit card numbers with valid checksums');
                i = 1;
                _c.label = 1;
            case 1:
                if (!(i < 20)) return [3 /*break*/, 4];
                _b = (_a = console).log;
                return [4 /*yield*/, creditCardGenerator.gen()];
            case 2:
                _b.apply(_a, [_c.sent()]);
                _c.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4:
                console.log('Check validity at: https://www.freeformatter.com/credit-card-number-generator-validator.html');
                return [2 /*return*/];
        }
    });
}); };
var runDemo = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                console.log('See source code in demo.ts and patterns.test.ts for detailed usage examples\n\n');
                return [4 /*yield*/, showBasicPattern()];
            case 1:
                _a.sent();
                return [4 /*yield*/, showFancyPattern()];
            case 2:
                _a.sent();
                return [4 /*yield*/, showPlates()];
            case 3:
                _a.sent();
                return [4 /*yield*/, generateCreditCardNums()];
            case 4:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.runDemo = runDemo;
// // A non-generator counter with seperate .getCounter() and .setCounter() methods
// const makeDumbCounter = (init: number) => ({
//   count: init,
//   getCounter: function () {
//     return this.count
//   },
//   setCounter: function (newCount: number) {
//     this.count = newCount
//   },
// })
// const dumbCounter = makeDumbCounter(99)
// // Pattern using seperate getCounter() and setCounter() methods;
// // Incrementer doubles the counter each iteration
// const dumbPattern = new Pattern(/<+ddddd>_(black|white)/, {
//   getCounter: () => dumbCounter.getCounter(),
//   setCounter: (newCount: number) => dumbCounter.setCounter(newCount),
//   counterIncrement: (current: number | string) => 2 * Number(current),
// })
// test('Separate getCounter, setCounter and incrementer methods', () => {
//   return dumbPattern.gen().then((result: string) => {
//     expect(result).toMatch(/00099_(black|white)/)
//   })
// })
// // Need to wrap in async/await, otherwise separate get/set calls cause
// // concurrency problems -- this is why the getCounter() method should ideally
// // atomically increment the counter in same operation.
// const generateTenMore = async () => {
//   for (let i = 1; i < 10; i++) {
//     await dumbPattern.gen()
//   }
//   return await dumbPattern.gen()
// }
// test('Generate 10 more', () => {
//   return generateTenMore().then((result: string) => {
//     expect(result).toMatch(/101376_(black|white)/)
//   })
// })
// test('Shorthand version of separated methods', () => {
//   return patternGen(/<+ddddd>_(black|white)/, {
//     getCounter: () => dumbCounter.getCounter(),
//     setCounter: (newCount: number) => dumbCounter.setCounter(newCount),
//     counterIncrement: (current: number | string) => 2 * Number(current),
//   }).then((result: string) => {
//     expect(result).toMatch(/^202752_(black|white)$/)
//   })
// })
// // Using a Unix timestamp as a custom replacment
// const getTimestamp = async () => {
//   const data = await fetch('https://showcase.api.linx.twenty57.net/UnixTime/tounix?date=now')
//   return await data.json()
// }
// const timestampPattern = new Pattern('[A-z0-9!@#$%^&]{8}-<?timestamp>', {
//   customReplacers: {
//     timestamp: getTimestamp,
//   },
// })
// test('Timestamp replacer', () => {
//   return timestampPattern.gen().then((result: string) => {
//     expect(result).toMatch(/[A-z0-9!@#$%^&]{8}-\d{10}/)
//   })
// })
// test('Shorthand verion of Timestamp replacer', () => {
//   return patternGen('[A-z0-9!@#$%^&]{8}-<?timestamp>', {
//     customReplacers: {
//       timestamp: getTimestamp,
//     },
//   }).then((result: string) => {
//     expect(result).toMatch(/[A-z0-9!@#$%^&]{8}-\d{10}/)
//   })
// })
