"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var patterns_1 = __importStar(require("./patterns"));
var customCounters_1 = require("./customCounters");
var checkdigit = require('checkdigit');
// Basic pattern generator, using internal counters and no customReplacers
var basicPattern = new patterns_1.default(/[A-Za-z]{1,9}-<+ddd>/);
// Between 1 and 9 alphabet chars, followed by - and a number padded with leading 0s to 3 digits
test('Generate single string - basicPattern', function () {
    return basicPattern.gen().then(function (result) {
        expect(result).toMatch(/^[A-Za-z]{1,9}-001$/);
    });
});
test('Generate 10 more', function () {
    for (var i = 1; i < 10; i++) {
        basicPattern.gen();
    }
    return basicPattern.gen().then(function (result) {
        expect(result).toMatch(/^[A-z]{1,9}-011$/);
    });
});
test('Shorthand version of basicPattern', function () {
    return patterns_1.patternGen(/[A-z]{1,9}-<+ddd>/).then(function (result) {
        expect(result).toMatch(/^[A-z]{1,9}-001$/);
    });
});
test("Don't increment counter", function () {
    return basicPattern.gen({ shouldIncrement: false }).then(function (result) {
        expect(result).toMatch(/^[A-z]{1,9}-011$/);
    });
});
// Basic pattern generator with counter starting from 100 and one custom replacer. Pattern is in string form.
var basicPattern2 = new patterns_1.default('<+>_(green|blue|red)_<?r1>', {
    counterInit: 100,
    customReplacers: {
        r1: function () { return 'TEXT'; },
    },
});
test('Generate single string - basicPattern2', function () {
    return basicPattern2.gen().then(function (result) {
        expect(result).toMatch(/^100_(green|blue|red)_TEXT$/);
    });
});
test('Generate 10 thousand more', function () {
    for (var i = 1; i < 10000; i++) {
        basicPattern2.gen();
    }
    return basicPattern2.gen().then(function (result) {
        expect(result).toMatch(/^10100_(green|blue|red)_TEXT$/);
    });
});
test('Shorthand version of basicPattern2', function () {
    return patterns_1.patternGen('<+>_(green|blue|red)_<?r1>', {
        counterInit: 666,
        customReplacers: {
            r1: function () { return 'TEXT'; },
        },
    }).then(function (result) {
        expect(result).toMatch(/^666_(green|blue|red)_TEXT$/);
    });
});
// Function to fetch an item from an online API
var getAlbumString = function (key) { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, axios_1.default('https://jsonplaceholder.typicode.com/albums')];
            case 1:
                response = _a.sent();
                return [2 /*return*/, response.data[key].title];
        }
    });
}); };
// More complex pattern with 2 custom replacers and a Intl formatted counter, and a non-standard incrementing function
var fancyPattern = new patterns_1.default(/^Album name: <?album>, serial: [A-Z]{3}_<+d> \(<?upper>$\)/, {
    counterInit: 5000,
    counterIncrement: function (prev) { return Number(prev) + 100; },
    customReplacers: {
        album: getAlbumString,
        upper: function (str) { return str.toUpperCase(); },
    },
    numberFormat: new Intl.NumberFormat('en-US'),
});
test('Generate single string - fancyPattern', function () {
    return fancyPattern
        .gen({
        customArgs: {
            album: 10,
            upper: '_end',
        },
    })
        .then(function (result) {
        expect(result).toMatch(/^Album name: quam nostrum impedit mollitia quod et dolor, serial: [A-Z]{3}_5,000 \(_END\)$/);
    });
});
test('Generate 3 more', function () {
    for (var i = 1; i < 3; i++) {
        fancyPattern.gen({
            customArgs: {
                album: i * 4,
                upper: 'anyTHING',
            },
        });
    }
    return fancyPattern
        .gen({
        customArgs: {
            album: 20,
            upper: '--done!',
        },
    })
        .then(function (result) {
        expect(result).toMatch(/^Album name: repudiandae voluptatem optio est consequatur rem in temporibus et, serial: [A-Z]{3}_5,300 \(--DONE!\)$/);
    });
});
// NZ Number plate generator:
var plates = customCounters_1.generatePlates();
// Pattern with non-numerical "counter", used twice in a string
var platePattern = new patterns_1.default('<+>_<+ddd>', { getCounter: function () { return plates.next(); } });
test('Generate a double NZ number plate string', function () {
    return platePattern.gen().then(function (result) {
        expect(result).toMatch(/^AAA100_AAA100$/);
    });
});
test('Generate 10 more plates', function () {
    for (var i = 1; i < 10; i++) {
        platePattern.gen();
    }
    return platePattern.gen().then(function (result) {
        expect(result).toMatch(/^AAA110_AAA110$/);
    });
});
test('Return same result without incrementing', function () {
    return platePattern.gen({ shouldIncrement: false }).then(function (result) {
        expect(result).toMatch(/^AAA110_AAA110$/);
    });
});
// Shorthand version, with a new plate generator
var plates2 = customCounters_1.generatePlates('MZZ998');
patterns_1.patternGen('<+>_<+ddd>', { getCounter: function () { return plates2.next(); } });
patterns_1.patternGen('<+>_<+ddd>', { getCounter: function () { return plates2.next(); } });
patterns_1.patternGen('<+>_<+ddd>', { getCounter: function () { return plates2.next(); } });
test('Shorthand version of platePattern', function () {
    return patterns_1.patternGen('<+>_<+ddd>', { getCounter: function () { return plates2.next(); } }).then(function (result) {
        expect(result).toMatch(/^NAA101_NAA101$/);
    });
});
// A non-generator counter with seperate .getCounter() and .setCounter() methods
var makeDumbCounter = function (init) { return ({
    count: init,
    getCounter: function () {
        return this.count;
    },
    setCounter: function (newCount) {
        this.count = newCount;
    },
}); };
var dumbCounter = makeDumbCounter(99);
// Pattern using seperate getCounter() and setCounter() methods;
// Incrementer doubles the counter each iteration
var dumbPattern = new patterns_1.default(/^<+ddddd>_(black|white)$/, {
    getCounter: function () { return dumbCounter.getCounter(); },
    setCounter: function (newCount) { return dumbCounter.setCounter(newCount); },
    counterIncrement: function (current) { return 2 * Number(current); },
});
test('Separate getCounter, setCounter and incrementer methods', function () {
    return dumbPattern.gen().then(function (result) {
        expect(result).toMatch(/^00099_(black|white)$/);
    });
});
// Need to wrap in async/await, otherwise separate get/set calls cause
// concurrency problems -- this is why the getCounter() method should ideally
// atomically increment the counter in same operation.
var generateTenMore = function () { return __awaiter(void 0, void 0, void 0, function () {
    var i;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                i = 1;
                _a.label = 1;
            case 1:
                if (!(i < 10)) return [3 /*break*/, 4];
                return [4 /*yield*/, dumbPattern.gen()];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [4 /*yield*/, dumbPattern.gen()];
            case 5: return [2 /*return*/, _a.sent()];
        }
    });
}); };
test('Generate 10 more', function () {
    return generateTenMore().then(function (result) {
        expect(result).toMatch(/^101376_(black|white)$/);
    });
});
test('Shorthand version of separated methods', function () {
    return patterns_1.patternGen(/<+ddddd>_(black|white)/, {
        getCounter: function () { return dumbCounter.getCounter(); },
        setCounter: function (newCount) { return dumbCounter.setCounter(newCount); },
        counterIncrement: function (current) { return 2 * Number(current); },
    }).then(function (result) {
        expect(result).toMatch(/^202752_(black|white)$/);
    });
});
// Using a Unix timestamp as a custom replacment
var getTimestamp = function () { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, axios_1.default('https://showcase.api.linx.twenty57.net/UnixTime/tounix?date=now')];
            case 1:
                response = _a.sent();
                return [2 /*return*/, response.data];
        }
    });
}); };
var timestampPattern = new patterns_1.default('[A-z0-9!@#$%^&]{8}-<?timestamp>', {
    customReplacers: {
        timestamp: getTimestamp,
    },
});
test('Timestamp replacer', function () {
    return timestampPattern.gen().then(function (result) {
        expect(result).toMatch(/^[A-z0-9!@#$%^&]{8}-\d{10}$/);
    });
});
test('Shorthand verion of Timestamp replacer', function () {
    return patterns_1.patternGen('[A-z0-9!@#$%^&]{8}-<?timestamp>', {
        customReplacers: {
            timestamp: getTimestamp,
        },
    }).then(function (result) {
        expect(result).toMatch(/^[A-z0-9!@#$%^&]{8}-\d{10}$/);
    });
});
// Use regex random results as arguments in functions
var dynamicArgPattern = new patterns_1.default(/^([a-z]{3,6})-(test)-<+ddd>-<?upper(1, 2)>-<?lower>$/, {
    customReplacers: {
        upper: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return args.join('').toUpperCase();
        },
        lower: function (chars) { return chars.toLowerCase(); },
    },
});
test('Use regex output as arguments in custom replacer functions -- dynamicArgPattern', function () {
    return dynamicArgPattern.gen({ customArgs: { lower: 'SomEThiNG' } }).then(function (result) {
        expect(result).toMatch(/^([a-z]{3,6})-(test)-\d{3}-[A-Z]{3,6}TEST-something$/);
    });
});
// Generate random credit card numbers, including correct check digit
var calculateCheckDigit = function (digits) {
    return checkdigit.mod10.create(digits.join('').replace(/\W/g, ''));
};
var visaCardPattern = new patterns_1.default(/(4[0-9]|51|52|53|54|55)([0-9]{2}) ([0-9]{4} [0-9]{4} [0-9]{3})<?checksum(1, 2, 3)>/, {
    customReplacers: {
        checksum: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return calculateCheckDigit(args);
        },
    },
});
test('Generate valid random credit card number (with checkdigit)', function () {
    return visaCardPattern.gen().then(function (result) {
        expect(result).toMatch(/^(4[0-9]|51|52|53|54|55)([0-9]{2}) [0-9]{4} [0-9]{4} [0-9]{4}$/);
    });
});
// Extract object data
var dataPattern = new patterns_1.default(/<?f1>-[A-Z]{3}-<user.firstName>-<+ddd>/, {
    customReplacers: { f1: function () { return 'Testing'; } },
    counterInit: 123,
});
test('Extract object properties from replacer field (info.firstName)', function () {
    return dataPattern.gen({ data: { user: { firstName: 'Carl' } } }).then(function (result) {
        expect(result).toMatch(/^Testing-[A-Z]{3}-Carl-123$/);
    });
});
test('Object property field missing', function () {
    return dataPattern.gen({ data: { info: 'Nope' } }).then(function (result) {
        expect(result).toMatch(/^Testing-[A-Z]{3}--124$/);
    });
});
test('Shorthand form, with two fields and a fallback', function () {
    return patterns_1.patternGen(/<?f1>-[A-Z]{3}-<user.firstName>_<user.lastName>-<+ddd>/, {
        customReplacers: {
            f1: function (chars) { return chars.toUpperCase(); },
        },
        counterInit: 10,
        fallbackString: 'MISSING_PROPERTY',
    }, { customArgs: { f1: 'flutter' }, data: { user: { firstName: 'Bodhi' } } }).then(function (result) {
        expect(result).toMatch(/^FLUTTER-[A-Z]{3}-Bodhi_MISSING_PROPERTY-010$/);
    });
});
// Handle literal <>
var patternWithLiterals = new patterns_1.default(/\<1\>-[A-Z]{3}-<+dd>-<?f1>/, {
    customReplacers: { f1: function () { return 'Testing'; } },
});
test('Pattern with literal <> chars', function () {
    return patternWithLiterals.gen().then(function (result) {
        expect(result).toMatch(/^<1>-[A-Z]{3}-01-Testing$/);
    });
});
test('Pattern with incomplete (non-closed) literal < char', function () {
    return patterns_1.patternGen(/Another\<<+dd>-\>\>_<+dddd>_DONE/).then(function (result) {
        expect(result).toMatch(/^Another<01->>_0001_DONE$/);
    });
});
// Change Pattern properties in place
var patternForMutation = new patterns_1.default(/[A-Z]{3}-<+ddd>/);
test('Pattern output before update Pattern', function () {
    return patternForMutation.gen().then(function (result) {
        expect(result).toMatch(/^[A-Z]{3}-001/);
    });
});
test('Pattern output after update Pattern', function () {
    patternForMutation.setPattern(/[A-Z]{4} - <+dddd>/);
    return patternForMutation.gen().then(function (result) {
        expect(result).toMatch(/^[A-Z]{4} - 0002/);
    });
});
test('Pattern output after update Options', function () {
    patternForMutation.setOptions({
        getCounter: function () { return 1000; },
    });
    return patternForMutation.gen().then(function (result) {
        expect(result).toMatch(/^[A-Z]{4} - 1000/);
    });
});
