declare type GenericObject = {
    [key: string]: GenericObject | unknown;
};
export interface CustomReplacers {
    [key: string]: Function;
}
export interface CustomArgs {
    [key: string]: unknown;
}
export interface GenerateArgs {
    shouldIncrement?: boolean;
    customArgs?: CustomArgs;
    data?: GenericObject | unknown;
}
export interface PatternGeneratorOptions {
    getCounter?: Function;
    setCounter?: Function;
    counterIncrement?: (input: string | number) => string | number;
    counterInit?: number;
    customReplacers?: CustomReplacers;
    numberFormat?: Intl.NumberFormat;
    fallbackString?: string;
    defaultRangeAdd?: [number, number];
    defaultRangeSubtract?: [number, number];
    regexMax?: number;
}
declare type CounterReplacement = {
    type: 'counter';
    length: number;
};
declare type FunctionReplacement = {
    type: 'function';
    funcName: string;
    args?: any;
};
declare type DataReplacement = {
    type: 'data';
    property: string;
};
export interface SubstitutionMap {
    [key: string]: CounterReplacement | FunctionReplacement | DataReplacement;
}
export declare type RandExpOptions = {
    defaultRangeAdd?: [number, number];
    defaultRangeSubtract?: [number, number];
    regexMax?: number;
};
export {};
